#include <stdio.h> 
#include <string.h>
#include <malloc.h>

int count = 0;

typedef struct WordsData
{
	int length;
	char word[30]; 
	struct WordsData *next; 
} words;

words *head, *tail; 

void InitialWork(); 
void InputFileData(); 
void OutputFileData(); 
void InsertWords(); 

void main()
{
	InitialWork(); 
	InputFileData(); 	
    OutputFileData(); 

	getch();
}

void InitialWork()
{
	head = (words *)malloc(sizeof(words)); 
	tail = (words *)malloc(sizeof(words)); 
	head->next = tail; 
	tail->next = tail; 
}

void InsertWords(int len, char *word)
{
	words *w, *cur, *com; 
	int c = 0; 

	w = (words *)malloc(sizeof(words)); 
	
	w->length = len; 
	strcpy(w->word, word); 
	
	cur = head;
	com = cur->next; 

	while(c <= count) 
	{
		if(w->length < com->length)
		{                           
			cur->next = w;          
			w->next = com;
			break;
		}

		cur = cur->next;  
		com = cur->next;
	}
}

void InputFileData()
{
	FILE *fp;
	char c, word[30] = ""; 
	int	length = 0; 
	bool space = false;

	fp = fopen("Input.txt", "r"); 

	while((c = getc(fp)) != EOF)
	{
		if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z')) 
		{
			space = false;
			word[length++] = c; 
		}
		else if((c == ' ' || c == '\n' || c == '\t') && (space != true)) 
		{
			InsertWords(length, word); 
			memcpy(word, "", 30); 
			length = 0; 
			space = true;
			count++; 
		}
		else 
			continue;
	}
	InsertWords(length, word); 

	fclose(fp); 
}

void OutputFileData()
{
	FILE *fp; 
	words *cur = head->next; 

	fp = fopen("Output.txt", "w");
 
	while(cur != tail)
	{
		fprintf(fp, "%s\n", cur->word); 
		cur = cur->next;
	}

        printf("۾ ϷǾϴ.\nܾ 'Output.txt'   ĵǾϴ.\n ܾ  : %d\n", count);
	fclose(fp); 
}

